final-project/routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use App\Http\Controllers\UserController;
use App\Http\Controllers\AdminController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CategoryController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\ShopController;
use App\Http\Controllers\ProductController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [HomeController::class, 'index'])->name('home');

Route::get('/shop', [ShopController::class, 'index']);
Route::get('/shop/{id}', [ShopController::class, 'show']);

Route::get('product/{id}', [ProductController::class, 'showfront']);

Route::get('/cart', [CartController::class, 'index']);
Route::post('/add-to-cart', [CartController::class, 'addToCart']);
Route::delete('/delete-cart/{id}', [CartController::class, 'delete']);

Route::get('/checkout', [OrderController::class, 'index']);
Route::post('/checkout', [OrderController::class, 'store']);

Route::get('/admin', function () {
    return view('admin.index');
});

Route::resource('/admin/category', CategoryController::class);

Auth::routes();

Route::group(['prefix'=>'admin', 'middleware'=>['isAdmin','auth']], function(){
    Route::get('dashboard',[AdminController::class,'index'])->name('admin.dashboard');
});

Route::group(['prefix'=>'user', 'middleware'=>['isUser','auth']], function(){
    Route::get('dashboard',[UserController::class,'index'])->name('user.dashboard');
});
Route::resource('/admin/product', ProductController::class);

final-project/app/Models/Product.php
<?php

namespace App\Models;

use App\Models\Categories;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    use HasFactory;
    protected $table = 'products';
    protected $fillable = ['name', 'image','category_id','quantity','price'];

    public function categories()
    {
        return $this->belongsTo(Categories::class, 'category_id');
    }
}

final-project/app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Models\Product;
use App\Models\Categories;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = Product::paginate(10);
        return view('admin.product.index', compact('products'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = Categories::orderBy('created_at','desc')->get();
        return view('admin.product.create', [
            'categories' => $categories
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required',
            'image' => 'required|image|mimes:jpeg,png,jpg,gif|max:2048',
            'categories' => 'required',
            'price' => 'required',
            'quantity' => 'required',
            'description' => 'required|max:255|string',
        ]);

        $products = new Product();
        $products->name = $request->input('name');
        $products->category_id = $request->input('categories');
        $products->price = $request->input('price');
        $products->quantity = $request->input('quantity');
        $products->description = $request->input('description');

        if ($request->hasFile('image')) {
            $image = $request->file('image');
            $imageName = time() . '.' . $image->getClientOriginalExtension();
            $image->move(public_path('images'), $imageName);
            $products->image = $imageName;
        }

        $products->save();

        
        return redirect()->route('product.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $products = Product::findOrFail($id);
        $categories = Categories::find($products->category_id);
        return view('admin.product.show', compact('products','categories'));
    }

    public function showfront($id)
    {
        $product = Product::findOrFail($id);
        return view('frontend.product', compact('product'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $products = Product::findOrFail($id);
        $categories = Categories::find($products->category_id);
        return view('admin.product.edit', compact('products','categories'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $products = Product::findOrFail($id);
        $categories = Categories::find($products->category_id);

        $this->validate($request, [
            'name' => 'required',
            'image' => 'required|image|mimes:jpeg,png,jpg,gif|max:2048',
            'categories' => 'required',
            'price' => 'required',
            'quantity' => 'required',
            'description' => 'required|max:255|string',
        ]);


        if ($request->hasFile('image')) {
            $image = $request->file('image');
            $imageName = time() . '.' . $image->getClientOriginalExtension();
            $image->move(public_path('images'), $imageName);
            $products->image = $imageName;
        }

        $products->name = $request->name;
        $products->category_id = $categories->id;
        $products->price = $request->input('price');
        $products->quantity = $request->input('quantity');
        $products->description = $request->input('description');

        $products->update();
        return redirect()->route('product.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $category = Categories::findOrFail($id);

        $category->delete();

        return redirect(Route('product.index'));
    }
}

final-project/resources/views/admin/product/create.blade.php
@extends('layout.dashboard')

@push('scripts')
<script src="https://cdn.tiny.cloud/1/swyppviw5nqhq4h1ifu8kehzq16vtbqp98svjoofs3l7kl4x/tinymce/6/tinymce.min.js" referrerpolicy="origin"></script>
@endpush

@section('menu')
Kategori
@endsection

@section('title')
Buat Kategori
@endsection

@section('content')
<div class="card mb-4">
    <div class="card-body">
        <form action="{{ route('product.store') }}" method="POST" enctype="multipart/form-data">
            <div class="row">
                @csrf
                <div class="col-md-6">
                    <div class="mb-3">
                        <label class="form-label" for="name">Nama Barang</label>
                        <input type="text" class="form-control" id="name" name="name"
                            placeholder="Masukkan nama kategori">
                        @error('name')
                        <p class="alert alert-danger">
                            {{ $message }}
                        </p>
                        @enderror
                    </div>
                    <div class="mb-3">
                        <label class="form-label" for="categories">Kategori</label>
                        <select id="defaultSelect" name="categories" class="form-select">
                            <option value="">Masukkan Kategori</option>
                            @foreach ($categories as $data)
                            <option value="{{ $data->id }}">{{ $data->name }}</option>
                            @endforeach
                        </select>
                        @error('categories')
                        <p class="alert alert-danger">
                            {{ $message }}
                        </p>
                        @enderror
                    </div>
                    <div class="mb-3">
                        <label for="image" class="form-label">Gambar</label>
                        <input class="form-control" type="file" id="image" name="image">
                        @error('image')
                        <p class="alert alert-danger">
                            {{ $message }}
                        </p>
                        @enderror
                    </div>
                    <div class="mb-3">
                        <label class="form-label" for="Price">Harga</label>
                        <div class="input-group input-group-merge">
                            <span class="input-group-text">Rp</span>
                            <input type="number" min="1000" class="form-control" name="price" placeholder="100" aria-label="Amount (to the nearest dollar)">
                            <span class="input-group-text">.00</span>
                        </div>
                        @error('PRIC')
                        <p class="alert alert-danger">
                            {{ $message }}
                        </p>
                        @enderror
                    </div>
                    <button type="submit" class="btn btn-primary">Tambahkan</button>
                </div>
                <div class="col-md-6">
                    <div class="mb-3">
                        <label class="form-label" for="Price">Stock</label>
                        <input type="number" min="1" name="quantity" class="form-control" name="price" placeholder="100">
                        @error('price')
                        <p class="alert alert-danger">
                            {{ $message }}
                        </p>
                        @enderror
                    </div>
                    <div>
                        <label for="exampleFormControlTextarea1" class="form-label">Deskripsi</label>
                        <textarea class="form-control" name="description" id="exampleFormControlTextarea1" rows="8"></textarea>
                        @error('description')
                        <p class="alert alert-danger">
                            {{ $message }}
                        </p>
                        @enderror
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
</div>
@endsection

@push('tinyMCE')
<script>
  tinymce.init({
    selector: '#exampleFormControlTextarea1',
    height: 300,
    plugins: [
      'advlist autolink lists link image charmap print preview anchor',
      'searchreplace visualblocks code fullscreen',
      'insertdatetime media table paste code help wordcount'
    ],
    toolbar: 'undo redo | formatselect | ' +
      'bold italic backcolor | alignleft aligncenter ' +
      'alignright alignjustify | bullist numlist outdent indent | ' +
      'removeformat | help',
  });
</script>
@endpush

@push('select2')
<script>
    $(document).ready(function() {
        $('#defaultSelect').select2();
    });
</script>
@endpush

final-project/resources/views/admin/product/edit.blade.php
@extends('layout.dashboard')

@section('menu')
Kategori
@endsection

@section('title')
Buat Kategori
@endsection

@section('content')
<div class="card mb-4">
    <div class="card-body">
        <form action="{{ route('product.update',$products->id) }}" method="POST" enctype="multipart/form-data">
            <div class="row">
                @csrf
                @method('PUT')
                <div class="col-md-6">
                    <div class="mb-3">
                        <label class="form-label" for="name">Nama Barang</label>
                        <input type="text" class="form-control" id="name" name="name" value="{{$products->name}} "
                            >
                    </div>
                    <div class="mb-3">
                        <label class="form-label" for="categories">Kategori</label>
                        <input type="text" class="form-control" value="{{$categories->name}}" >
                    </div>
                    <div class="mb-3">
                        <label class="form-label" for="name">Harga</label>
                        <input type="text" class="form-control" id="name" name="price" value="{{$products->price}}" >
                    </div>
                    <div class="mb-3">
                        <label for="image" class="form-label">Gambar</label>
                        <input class="form-control" value="{{asset('images/'. $products->image)}}" type="file" id="image" name="image">
                        <img style="width: 100px;" class="img-fluid" src="{{asset('images/'. $products->image)}}" alt="image">
                    </div>
                    <button type="submit" class="btn btn-primary">Simpan</button>
                </div>
                <div class="col-md-6">
                  <div class="mb-3">
                    <label class="form-label" for="name">Stock</label>
                    <input type="text" name="quantity" class="form-control" id="name" name="name"
                        value="{{number_format($products->quantity, 0, '', '.')}}" >
                </div>
                    <div>
                        <label for="exampleFormControlTextarea1" class="form-label">Deskripsi</label>
                        <textarea class="form-control" name="description" name="description" id="exampleFormControlTextarea1" rows="11" >{{ $products->description }}</textarea>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
</div>
@endsection

final-project/resources/views/admin/product/index.blade.php
@extends('layout.dashboard')

@section('menu')
  Produk
@endsection

@section('title')
   List 
@endsection

@section('content')
<div class="card py-2">
  <div class="table-responsive text-nowrap">
    <table class="table">
      <thead>
        <tr>
          <th>No</th>
          <th class="text-center">Gambar</th>
          <th>Nama Barang</th>
          <th>Harga</th>
          <th>Jumlah</th>
          <th>Deskripsi</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody class="table-border-bottom-0" style="height: 150px">
        @forelse ($products as $key => $product)
        <tr>
          <td>{{$key + 1}}</td>
          <td style="width: 125px;"><a href="{{ Route('product.show', $product->id) }}"><img style="width: 100px;" class="img-fluid" src="{{asset('images/'. $product->image)}}" alt="image"></a></td>
          <td><a class="text-black" href="product/{{$product->id}}">{{$product->name}}</a></td>
          <td><a class="text-black" href="product/{{$product->id}}">{{number_format($product->price, 2, '.', ',')}}</a></td>
          <td><a class="text-black" href="product/{{$product->id}}">{{$product->quantity}}</a></td>
          <td><a class="text-black" href="product/{{$product->id}}">{{ Str::limit(strip_tags($product->description), 10, '...')}}</a></td>
          <td>
            <div class="dropdown">
              <button type="button" class="btn p-0 dropdown-toggle hide-arrow" data-bs-toggle="dropdown">
                <i class="bx bx-dots-vertical-rounded"></i>
              </button>
              <div class="dropdown-menu">
                <a class="dropdown-item" href="{{Route('product.edit',$product->id)}}"><i class="bx bx-edit-alt me-1"></i> Edit</a>
                <form action="{{Route('product.destroy',$product->id)}}" method="POST">
                  @csrf
                  @method('DELETE')
                  <button type="submit" class="dropdown-item">
                    <i class="bx bx-trash me-1"></i> Delete
                  </button>
                </form>
              </div>
            </div>
          </td>
        </tr>
        @empty
        <tr>
          <td colspan="7" class="text-center">No Data Found</td>
        </tr>
        @endforelse
       
      </tbody>
    </table>
  </div>
</div>
@endsection

final-project/resources/views/admin/product/show.blade.php
@extends('layout.dashboard')

@section('menu')
Kategori
@endsection

@section('title')
Buat Kategori
@endsection

@section('content')
<div class="card mb-4">
    <div class="card-body">
        <form action="{{ route('product.store') }}" method="POST" enctype="multipart/form-data">
            <div class="row">
                @csrf
                <div class="col-md-6">
                    <div class="mb-3">
                        <label class="form-label" for="name">Nama Barang</label>
                        <input type="text" class="form-control" id="name" name="name" value="{{$products->name}} "
                            readonly>
                    </div>
                    <div class="mb-3">
                        <label class="form-label" for="categories">Kategori</label>
                        <input type="text" class="form-control" value="{{$categories->name}}" readonly>
                    </div>
                    <div class="mb-3">
                        <label class="form-label" for="name">Harga</label>
                        <input type="text" class="form-control" id="name" name="name" value="{{number_format($products->price, 2, '.', ',')}}" readonly>
                    </div>
                    <div class="mb-3">
                        <label for="image" class="form-label">Gambar</label>
                        <br>
                        <img style="width: 100px;" class="img-fluid" src="{{asset('images/'. $products->image)}}" alt="image">
                    </div>
                    <a type="submit" href="{{route('product.index')}}" class="btn btn-primary">Kemabali</a>
                </div>
                <div class="col-md-6">
                  <div class="mb-3">
                    <label class="form-label" for="name">Stock</label>
                    <input type="text" class="form-control" id="name" name="name"
                        value="{{number_format($products->quantity, 0, '', '.')}}" readonly>
                </div>
                    <div>
                        <label for="exampleFormControlTextarea1" class="form-label">Deskripsi</label>
                        <textarea class="form-control" name="description" id="exampleFormControlTextarea1" rows="11" readonly>{{strip_tags($products->description)}}</textarea>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
</div>
@endsection